#ifndef INCLUDE__Disassembler_hxx
#define INCLUDE__Disassembler_hxx

#include <string>
#include <functional>

#include "disassembler/BasicBlock.hxx"
#include "disassembler/Function.hxx"


class Disassembler {
public:
	Disassembler(const std::string& filename) {}
    virtual ~Disassembler() {}

	void getSymbols();
	uint64_t entryAddress();
	virtual BasicBlock * getBasicBlock(uint64_t address) = 0;

	virtual void forEachFunction(std::function<void (uint64_t, Function*)> callback) = 0;
	virtual void printEachInstruction(uint64_t start, uint64_t end,
									  std::function<void (uint8_t*, size_t, const std::string&)> fun) = 0;
protected:
    virtual bool isFunctionCall(uint64_t address) = 0;
    virtual bool isJump(uint64_t address) = 0;
};

#endif
